/*
	Ants.cpp - Copyright (C)EdzUp
	Programmed by Ed 'EdzUp' Upton

	Original version written in 1989
*/


#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>

struct {
	int x;
	int y;
	int facing;				//the ants facing direction
	int colour;				//this is the ants main colour
} ant[ 10 ];

typedef unsigned char byte;

byte far *VGA = (byte far*)0xA0000000L;
unsigned short offset;
int Count;

void PlotFast( int x, int y, char colour );
void Plot( int x, int y, char colour );
void VGAInit( void );
void TextMode( void );
void InitGame( void );
void UpdateAnts( void );

int main( int argc, char **argv ) {
	VGAInit();
	InitGame();

	do {
	   UpdateAnts();
	   delay( 1 );
	} while (kbhit()==0);
	TextMode();
	return( 0 );	//return success
}

void UpdateAnts( void ) {
	//this will plot and update the ants
	int CA;
	int off;

	for ( CA=0; CA<10; CA++ ) {
		switch( ant[ CA ].facing ) {
			case 0:
				ant[ CA ].y--;
				if ( ant[ CA ].y<0 ) ant[ CA ].y=199;
				break;
			case 1:
				ant[ CA ].x++;
				if ( ant[ CA ].x>319 ) ant[ CA ].x =0;
				break;
			case 2:
				ant[ CA ].y++;
				if ( ant[ CA ].y>199 ) ant[ CA ].y=0;
				break;
			case 3:
				ant[ CA ].x--;
				if ( ant[ CA ].x<0 ) ant[ CA ].x=319;
				break;
			default:
				break;
		}
		off = (ant[ CA ].y <<8 ) +(ant[ CA ].y <<6 ) +ant[ CA ].x;
		if ( VGA[ off ]!=0){
			ant[ CA ].facing--;
			if ( ant[ CA ].facing<0 ) ant[ CA ].facing=3;
			PlotFast( ant[ CA ].x, ant[ CA ].y, 0 );
		} else {
			ant[ CA ].facing++;
			if ( ant[ CA ].facing>3 ) ant[ CA ].facing=0;
			PlotFast( ant[ CA ].x, ant[ CA ].y, ant[ CA ].colour );
		}
	}
}

void InitGame( void ) {
	//this will set out the basic ants
	int CA;

	for (CA=0; CA<10; CA++ ) {
		ant[ CA ].x = random( 320 );
		ant[ CA ].y = random( 200 );
		ant[ CA ].facing = random( 4 );
		do {
			ant[ CA ].colour = random( 255 );
		} while( ant[ CA ].colour == 0 );
	}
}

void PlotFast( int x, int y, char colour ) {
	offset = (y<<8) +(y<<6) +x;
	VGA[ offset ] = colour;
}

void Plot( int x, int y, char colour ) {
	union REGS regs;

	regs.h.ah = 0x0C;               //function 0C pixel plot
	regs.h.al = colour;
	regs.x.cx = x;                  //x location from 0..319
	regs.x.dx = y;                  //y location from 0..199
	int86( 0x10, &regs, &regs );
}

void VGAInit( void ) {
	union REGS regs;

	regs.h.ah = 0x00;				//function 00h = mode set
	regs.h.al = 0x13;				//256-color VGA
	int86( 0x10, &regs, &regs );	//perform DOS call to interrupt 10
}

void TextMode( void ) {
	union REGS regs;

	regs.h.ah = 0x00;				//function 00h = mode set
	regs.h.al = 0x03;				//return to text mode 3
	int86( 0x10, &regs, &regs );	//do it
}